// Shield.cpp: Implementierung der Klasse CShield.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Shield.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_SERIAL (CShield, CObject, 1)
//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CShield::CShield()
{
	m_iShieldType = 0;
	m_iMaxShield = 0;
	m_iCurrentShield = 0;
	m_bRegenerative = FALSE;
}

CShield::~CShield()
{

}

//////////////////////////////////////////////////////////////////////
// Kopierkonstruktor
//////////////////////////////////////////////////////////////////////
CShield::CShield(const CShield & rhs)
{
	m_iShieldType = rhs.m_iShieldType;
	m_iCurrentShield = rhs.m_iCurrentShield;
	m_iMaxShield = rhs.m_iMaxShield;
	m_bRegenerative = rhs.m_bRegenerative;
}

//////////////////////////////////////////////////////////////////////
// Zuweisungsoperator
//////////////////////////////////////////////////////////////////////
CShield & CShield::operator=(const CShield & rhs)
{
	if (this == &rhs)
		return *this;
	m_iShieldType = rhs.m_iShieldType;
	m_iCurrentShield = rhs.m_iCurrentShield;
	m_iMaxShield = rhs.m_iMaxShield;
	m_bRegenerative = rhs.m_bRegenerative;
	return *this;
}

///////////////////////////////////////////////////////////////////////
// Speichern / Laden
///////////////////////////////////////////////////////////////////////
void CShield::Serialize(CArchive &ar)
{
	CObject::Serialize(ar);
	// wenn gespeichert wird
	if (ar.IsStoring())
	{
		ar << m_iShieldType;
		ar << m_iMaxShield;
		ar << m_iCurrentShield;
		ar << m_bRegenerative;
	}
	// wenn geladen wird
	if (ar.IsLoading())
	{
		ar >> m_iShieldType;
		ar >> m_iMaxShield;
		ar >> m_iCurrentShield;
		ar >> m_bRegenerative;
	}
}

void CShield::SetCurrentShield(int newCurrentShield)
{
	if (newCurrentShield < 0)
		m_iCurrentShield = 0;
	else if ((UINT)newCurrentShield > m_iCurrentShield)
		m_iCurrentShield = 0;
	else
		m_iCurrentShield = newCurrentShield;
}

void CShield::ModifyShield(UINT MaxShield, BYTE ShieldType, BOOLEAN Regenerative)
{
	m_iShieldType = ShieldType;
	m_iCurrentShield = MaxShield;
	m_iMaxShield = MaxShield;
	m_bRegenerative = Regenerative;
}
// Diese Funktion ldt die Schilde entsprechend ihrem Schildtyp wieder auf
void CShield::RechargeShields(int nMulti)
{
	int maxRecharge = m_iMaxShield - m_iCurrentShield;
	//Sind die Schilde unter dem Grenzwert?
	if ((m_iCurrentShield / m_iMaxShield) < ((m_iShieldType * 0.05) + 0.1))
		//Dann wird mit 0,25% je Tick regeneriert
		int Recharge = (int)(max(m_iMaxShield * 0.01f * 0.25f, 1);
	else 
		//Sonst wird mit 0,125% je Tick regeneriert
		int Recharge = (int)(max(m_iMaxShield * 0.01f * 0.125f, 1);
	if (Recharge > maxRecharge)
		Recharge = maxRecharge;
	m_iCurrentShield += Recharge;

/*	if (maxRecharge > 0)
	{
		CString s;
		s.Format("Recharge %d",Recharge);
		AfxMessageBox(s);
	}*/
}
// Diese Funktion ldt die Schilde entsprechend ihrem Schildtyp wieder auf
void CShield::RechargeShields(int nMulti)
{
	int maxRecharge = m_iMaxShield - m_iCurrentShield;
	//Schildtyp 0 bis 2
	if (m_iShieldType < 3)
	{
		//Sind die Schilde unter dem Grenzwert?
		if ((m_iCurrentShield / m_iMaxShield) < ((m_iShieldType * 0.1) + 0.15))
			//Dann wird mit 0,2% je Tick regeneriert
			int Recharge = (int)(max(m_iMaxShield * 0.01f * 0.2f, 1);
		else 
			//Sonst wird mit 0,1% je Tick regeneriert
			int Recharge = (int)(max(m_iMaxShield * 0.01f * 0.1f, 1);
	}
	//Schildtyp ber 2
	else
	{
		//Sind die Schilde unter dem Grenzwert?
		if ((m_iCurrentShield / m_iMaxShield) < ((m_iShieldType * 0.05) + 0.3))
			//Dann wird mit 0,2% je Tick regeneriert
			int Recharge = (int)(max(m_iMaxShield * 0.01f * 0.2f, 1);
		else 
			//Sonst wird mit 0,1% je Tick regeneriert
			int Recharge = (int)(max(m_iMaxShield * 0.01f * 0.1f, 1);
	}
	if (Recharge > maxRecharge)
		Recharge = maxRecharge;
	m_iCurrentShield += Recharge;

/*	if (maxRecharge > 0)
	{
		CString s;
		s.Format("Recharge %d",Recharge);
		AfxMessageBox(s);
	}*/
}
